import * as React from 'react';
import {
  IDropdownOption,
  Stack,
  PrimaryButton,
  TextField,
  Checkbox,
  Dropdown
} from 'office-ui-fabric-react';
import { toUri } from '../libs/utils/toUri';
import * as chainIDE from 'chainIDE';

import styles from './control.less';

export const Controls = () => {
  const { chainIDEProxyImpl } = chainIDE;

  const [fileContent, setFileContent] = React.useState('');
  const callApiFunction = chainIDEProxyImpl.getApiFunction(
    'chainIDE-pluginId.testFunction'
  );

  React.useEffect(() => {
    const currentProject = chainIDEProxyImpl.currentProject;
    chainIDEProxyImpl.fileSystemService
      .getFilesystemIndex(currentProject.currentProjectId)
      .then((res) => {
        console.log(res);
      })
      .catch((e) => console.log(e));

    chainIDEProxyImpl.fileSystemService
      .readFileString(toUri(currentProject.currentProjectId, './Storage.sol'))
      .then((res) => {
        setFileContent(res);
      })
      .catch((e) => console.log(e));
  }, []);

  return (
    <div className={styles.controls}>
      <Stack
        tokens={{ childrenGap: 15 }}
        styles={{ root: { paddingBottom: '15px' } }}>
        <Dropdown
          label="dropDown"
          onChanged={handleSelectNetwork}
          options={[
            {
              key: 'option1',
              text: 'option1'
            }
          ]}
        />

        <Checkbox label="test checkbox" name="DryRun" />

        <TextField label="test input" />

        <PrimaryButton onClick={() => callApiFunction() as void}>
          test button
        </PrimaryButton>

        <pre>{fileContent}</pre>
      </Stack>
    </div>
  );

  function handleSelectNetwork(option: IDropdownOption) {
    console.log(option);
  }
};
